//+---------------------------------------------------------------------+
//|                                                     T3_iAnchMom.mq5 | 
//|                                           Copyright  2006, Ramdass | 
//|                                                                     | 
//+---------------------------------------------------------------------+ 
//|     SmoothAlgorithms.mqh      |
//|   (): __\\MQL5\Include        |
//+---------------------------------------------------------------------+
#property copyright "Copyright  2006, Ramdass"
#property link ""
//---   
#property version   "1.00"
//---     
#property indicator_separate_window
//---   
#property indicator_buffers 2 
//---     
#property indicator_plots   1
//+-----------------------------------+
//|       |
//+-----------------------------------+
//---      
#property indicator_type1   DRAW_COLOR_ARROW
#property indicator_color1  clrRed,clrMagenta,clrGray,clrBlue,clrGreen
#property indicator_width1  2
//---   
#property indicator_label1  "T3_iAnchMom"
//+-----------------------------------+
//|    XMA              |
//+-----------------------------------+
#include <SmoothAlgorithms.mqh> 
//+-----------------------------------+
//---    CT3   SmoothAlgorithms.mqh
CT3 T3A,T3B;
//+-----------------------------------+
//|         |
//+-----------------------------------+
input uint FastT3=3;   //   T3
input uint SlowT3=8;   //   T3                   
input int T3Phase=15;  //  
//+-----------------------------------+
//---   ,   
//---      
double IndBuffer[],ColorIndBuffer[];
//---      
int min_rates_total;
//+------------------------------------------------------------------+   
//| T3_iAnchMom indicator initialization function                    | 
//+------------------------------------------------------------------+ 
void OnInit()
  {
//---     
   min_rates_total=2;
//---      
   SetIndexBuffer(0,IndBuffer,INDICATOR_DATA);
//---       
   ArraySetAsSeries(IndBuffer,true);
//---      
   SetIndexBuffer(1,ColorIndBuffer,INDICATOR_COLOR_INDEX);
//---       
   ArraySetAsSeries(ColorIndBuffer,true);
//---      
   PlotIndexSetInteger(0,PLOT_DRAW_BEGIN,min_rates_total);
//---   ,      
   PlotIndexSetDouble(0,PLOT_EMPTY_VALUE,EMPTY_VALUE);
//---           
   IndicatorSetString(INDICATOR_SHORTNAME,"T3_iAnchMom");
//---     
   IndicatorSetInteger(INDICATOR_DIGITS,6);
//---  
  }
//+------------------------------------------------------------------+ 
//| T3_iAnchMom iteration function                                   | 
//+------------------------------------------------------------------+ 
int OnCalculate(const int rates_total,    //       
                const int prev_calculated,//       
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---       
   if(rates_total<min_rates_total) return(0);
//---       
   double t3a,t3b;
//---        
   int first,bar;
//---    first    
   if(prev_calculated>rates_total || prev_calculated<=0) //      
      first=0; //      
   else first=prev_calculated-1; //      
//---    
   for(bar=first; bar<rates_total && !IsStopped(); bar++)
     {
      t3a=T3A.T3Series(0,prev_calculated,rates_total,0,T3Phase,FastT3,close[bar],bar,false);
      t3b=T3B.T3Series(0,prev_calculated,rates_total,0,SlowT3,T3Phase,close[bar],bar,false);
      if(t3b) IndBuffer[bar]=100*((t3a/t3b)-1);
      else IndBuffer[bar]=0.0;
     }
   if(prev_calculated>rates_total || prev_calculated<=0) first++;
//---    
   for(bar=first; bar<rates_total && !IsStopped(); bar++)
     {
      int clr=2;
      if(IndBuffer[bar]>0)
        {
         if(IndBuffer[bar]>IndBuffer[bar-1]) clr=4;
         if(IndBuffer[bar]<IndBuffer[bar-1]) clr=3;
        }
      if(IndBuffer[bar]<0)
        {
         if(IndBuffer[bar]<IndBuffer[bar-1]) clr=0;
         if(IndBuffer[bar]>IndBuffer[bar-1]) clr=1;
        }
      ColorIndBuffer[bar]=clr;
     }
//---          
   return(rates_total);
  }
//+------------------------------------------------------------------+
